GNU bug report logs - #46709
28.0.50; Emacs crash in gnutls_handshake

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Robert Pluim <rpluim@HIDDEN>; Keywords: patch fixed; Done: Robert Pluim <rpluim@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug marked as fixed in version 28.1, send any further explanations to 46709 <at> debbugs.gnu.org and Robert Pluim <rpluim@HIDDEN> Request was from Robert Pluim <rpluim@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Robert Pluim <rpluim@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 46709 <at> debbugs.gnu.org:


Received: (at 46709) by debbugs.gnu.org; 25 Feb 2021 16:04:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 25 11:04:59 2021
Received: from localhost ([127.0.0.1]:39054 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFJ8N-0005uT-36
	for submit <at> debbugs.gnu.org; Thu, 25 Feb 2021 11:04:59 -0500
Received: from mail-wr1-f45.google.com ([209.85.221.45]:33032)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>)
 id 1lFJ8G-0005tx-Vd; Thu, 25 Feb 2021 11:04:56 -0500
Received: by mail-wr1-f45.google.com with SMTP id 7so5785578wrz.0;
 Thu, 25 Feb 2021 08:04:52 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=1sbdk9l/35dmix7N91yNJ7zcYAkEf0KWURn4TWBRgnc=;
 b=A/HwDATbGvs0usoG9s5c1SB10sdtu7K3FpTl2HBgAAMablSidp2OPkB+iBAlEZlTm7
 soraHilke8TZ6Lz2U1nKEoQB5sSOSP5DIY80QBfbQtnWQmunNBrdfPt2KiaK1HtRml3T
 HWhO7bpbLPWJsr342I/En23cNcqowIqZiYwc54Ovr982CAX5hVPRSLj+o/KelVrSCvPk
 NSXYE+l1h+7HCYBVqnrbmgpLicyu8evrWQeV9HQ1gJZAm58dJsVPetizMu0gUms+xjip
 cZlf3xm7uL/QvTlL4umCX0ZVppM+gs8jv1Kp3Npa6X9/TJDpvLh6eLidkASapcuOvJBo
 G/xA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=1sbdk9l/35dmix7N91yNJ7zcYAkEf0KWURn4TWBRgnc=;
 b=En/YyIVv7dQ6TeqX1nnC6i6XmFqhLyxA0+LWq8a9Ao/jySSa9JrxGoZBgatrxXYpo9
 ER1+l4T+HnJay43D6yyvS8cnzBYjGHbkEcv8OPPWIUDW410J7gIz/VcxDnqkLnn4IQ4s
 JprmcqHdq8x7mMELeP0oC58EZc1UCcvKtB9Q6M41MOfMAaiiNSQYDkiikCnf2KMiK0Og
 oxAUqQtLiMlJA4WxGwZFuNTDyAoEpGL8QNo7X0EKlEAi3ippRseo2SrJt2lfmlgCMc1T
 fvQh8BZg12wUFBQPFCHMT3RUgwBd1pIBEZExFkVIN3c9fKfVB39dd1sF/Htq6FImeoTa
 qi2w==
X-Gm-Message-State: AOAM533PldG1z1f0TGjLu75InUnrgVr6oWZLMemolr4Ce9/ocXe20uY5
 lYE/qL07fLz4nJzHfDQPTPTb0arCtyGybw==
X-Google-Smtp-Source: ABdhPJyGoyj80rYPESDEJ8O0+Jws1ukuEMAiiepqHyu3yREAa+lIF0Wy52xsFWsQKG8xx+b/jcetPg==
X-Received: by 2002:adf:ef08:: with SMTP id e8mr4472451wro.200.1614269086468; 
 Thu, 25 Feb 2021 08:04:46 -0800 (PST)
Received: from rltb (91-175-207-237.subs.proxad.net. [91.175.207.237])
 by smtp.gmail.com with ESMTPSA id v6sm9469561wrx.32.2021.02.25.08.04.45
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 25 Feb 2021 08:04:45 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#46709: 28.0.50; Emacs crash in gnutls_handshake
References: <87czwsc5mz.fsf@HIDDEN> <87a6rt76ch.fsf@HIDDEN>
 <87o8g95r72.fsf@HIDDEN> <87k0qx5nqe.fsf@HIDDEN>
 <87pn0o41re.fsf@HIDDEN>
Date: Thu, 25 Feb 2021 17:04:44 +0100
In-Reply-To: <87pn0o41re.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 25 Feb 2021 16:15:33 +0100")
Message-ID: <87o8g8t9pf.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46709
Cc: 46709 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

tags 46709 fixed
close 46709 28.1
quit

>>>>> On Thu, 25 Feb 2021 16:15:33 +0100, Lars Ingebrigtsen <larsi@HIDDEN=
> said:

    Lars> Robert Pluim <rpluim@HIDDEN> writes:
    >> This really is the bug that keeps on giving. Turns out one of my
    >> network cards (the fast one <sniff>) is buggy, in that it will say
    >> it=CA=BCs passing packets when in fact it=CA=BCs not, so the patch i=
s in fact ok

    Lars> :-)

I=CA=BCve now beaten it into submission. All it took was a distro upgrade.

Committed as d84d69dfbc
Closing.

Eli, you might want to cherry-pick that to emacs-27, but I=CA=BCve not
tested it there.

Robert




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46709; Package emacs. Full text available.

Message received at 46709 <at> debbugs.gnu.org:


Received: (at 46709) by debbugs.gnu.org; 25 Feb 2021 15:15:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 25 10:15:45 2021
Received: from localhost ([127.0.0.1]:38986 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lFIMj-0004bX-7D
	for submit <at> debbugs.gnu.org; Thu, 25 Feb 2021 10:15:45 -0500
Received: from quimby.gnus.org ([95.216.78.240]:54694)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lFIMg-0004b6-MV
 for 46709 <at> debbugs.gnu.org; Thu, 25 Feb 2021 10:15:43 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=mxVsoMDiWAdQUo2DiMzBWwfJtDzhU29ygOXRIP4/h0U=; b=HW+Ym9/Qpm3m7cFKNLOLUTJFon
 CPUF+bSEo6Gbsbyi6hNYV+HM1N1qU4yMYh8UQQj7CmTnLZVqNcVjVTEHdwi67Guy+x5tjMT2Nl7os
 RxJHPSqZCBlMy0ynsldQ0ps3RKT18rwpLIy1/aP4b2GfNwarawsxckSz5fr6+4/7jK08=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lFIMY-0000fc-HP; Thu, 25 Feb 2021 16:15:36 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
Subject: Re: bug#46709: 28.0.50; Emacs crash in gnutls_handshake
References: <87czwsc5mz.fsf@HIDDEN> <87a6rt76ch.fsf@HIDDEN>
 <87o8g95r72.fsf@HIDDEN> <87k0qx5nqe.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEWsWEigk2I7Jh7/
 ///Ow/J8AAAAAWJLR0QDEQxM8gAAAAd0SU1FB+UCGQ8FOm2rAS4AAAFvSURBVCjPXdKxSsRAEAbg
 PyER2SpKFvQqFYUjTxFBQayi3FhYWecpcodapIqFjdUqQTb/Uzq7uUMxRcKXmcnO7AYoUbHDfFmR
 NsA4hQQ4JPRJPcNr6nQR0q5bMu05+W0NDfX6h3e5q8gqoAPp5VZvQOXA/kXuuemk1gXIF1mRa6nP
 ZojhgcQ0H5EoPHpnZWV8Io1GDp02VPlcmtAhGtg37+RJscZlubrzsGGINaxtLrvjKzHPOEcu98mQ
 p6XiVOd7SIYihemwrGEfUoeISqe42rhkr1O0QJ69urwojDbewZZ7Y6n7g5BpmwXLLKDVJuqFjlxo
 daszpgHPYVgir8MGVyx0uCFpdINlyVFfjBHIqkkjE8AI6pNaorPARHTff8BJYZESfYQfcJLuIt9D
 5nZoP0YsEeDJx37CzQynn570jCN8wDiDXDAuNOMInJ52OPnip3boEc5Wi5zfRjZc/kLPlV/7SLcR
 w8xvoX9LiBv+AJmh1aT6MaJrAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTAyLTI1VDE1OjA1OjU4
 KzAwOjAw3GOQMAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wMi0yNVQxNTowNTo1OCswMDowMK0+
 KIwAAAAASUVORK5CYII=
X-Now-Playing: Casino Music's _Jungle Love_: "C'est Extraordinaire"
Date: Thu, 25 Feb 2021 16:15:33 +0100
In-Reply-To: <87k0qx5nqe.fsf@HIDDEN> (Robert Pluim's message of "Wed, 24
 Feb 2021 19:23:21 +0100")
Message-ID: <87pn0o41re.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Robert Pluim <rpluim@HIDDEN> writes: > This really is the
    bug that keeps on giving. Turns out one of my > network cards (the fast one
    <sniff>) is buggy, in that it will say > itʼs passing packets when in fact
    itʼs not, so the patch is [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46709
Cc: 46709 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Robert Pluim <rpluim@HIDDEN> writes:

> This really is the bug that keeps on giving. Turns out one of my
> network cards (the fast one <sniff>) is buggy, in that it will say
> it=CA=BCs passing packets when in fact it=CA=BCs not, so the patch is in =
fact ok

:-)

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46709; Package emacs. Full text available.

Message received at 46709 <at> debbugs.gnu.org:


Received: (at 46709) by debbugs.gnu.org; 24 Feb 2021 18:23:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 24 13:23:31 2021
Received: from localhost ([127.0.0.1]:35889 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEyot-0001Ao-FH
	for submit <at> debbugs.gnu.org; Wed, 24 Feb 2021 13:23:31 -0500
Received: from mail-wm1-f46.google.com ([209.85.128.46]:51418)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1lEyor-0001Ab-Qo
 for 46709 <at> debbugs.gnu.org; Wed, 24 Feb 2021 13:23:30 -0500
Received: by mail-wm1-f46.google.com with SMTP id j187so2618259wmj.1
 for <46709 <at> debbugs.gnu.org>; Wed, 24 Feb 2021 10:23:29 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=5jGoJ5X1zHTzBxUd++T3KBrd3JbbLiqhgAmOhYW4uiw=;
 b=Y5TvumpRbpBmPAykXCCZ/CXb7pyqZwz8ALAVawewM7ZXsft/I1DdSoxHKXgahP+tjp
 0SI+IS6p5LqMN6llQOBTlbh0LyCJynn7P6ONiYHkoOok6CJqKY+qoyR4YkDoQbTDbzsO
 sawqdN4W60UU4uDHPu5w4Yd2lQNsISMwFwe9mBDjkfiA0wv8YwPbqWq4ZNZ3VvB8JJmN
 Mc6cymlUKC0NYD1Rbf7lrqv5KJxkmsA/DOZtXst6sDmAeo6+4NjEAt1J4iVX/9/Ey5ZA
 B5TztJdUlIANgYFW3O59VMNB1LC9Zn/DfR1Pitx7zVUqd2omjhLS7+gP3Ct/X2M32byp
 S2UA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=5jGoJ5X1zHTzBxUd++T3KBrd3JbbLiqhgAmOhYW4uiw=;
 b=hlE/tJ9TU2/xqoQ1lYUAuJ8PQxIi174/sRnoalZPfOzde0vi7jqPrJDibZss4aAuJz
 eZ21xdk2dyi4G+DY5mJchzpCw2EAwRbskHWEsUMe8ISkAxRnioChWl6VGitcjdT9S3st
 HprbHYBqECm+QeRoZ4H4RLs4vbj+WMsZBg5xC7fmJUlOgbLmJlU6+HHi5d7vE6sp73DA
 4FjkWELFkSnJDqmiZDKuKAxUimvwA39pYBHc3LlpJZj8WNnr9KHLAM2MvSkzj04LRvtJ
 /V9y4tXc+dSZ4VgybMV+VQuH6nfY6qACFWcg5GdZ/m0Uyv/lCZF7xd6u/22o8zwZ6zB6
 bsag==
X-Gm-Message-State: AOAM530b1kRPEIVxD3l3p/llyCiKbdTVl2mXRq5wXC5OUPaNbRzcGZHd
 hIrddwnIXwjsTniHzFeLZkm7v4tUSdeaGg==
X-Google-Smtp-Source: ABdhPJyQb1j00TO/YeJ6mf/Z0gBhXYDqMwcU+fCO9+wBNqoq2TsdwuDGHsupt2K7ZOtVQKrhMxd7Qg==
X-Received: by 2002:a05:600c:410e:: with SMTP id
 j14mr5062142wmi.36.1614191003511; 
 Wed, 24 Feb 2021 10:23:23 -0800 (PST)
Received: from rltb ([2a01:e0a:3f3:fb50:aed1:b8ff:fec0:58ef])
 by smtp.gmail.com with ESMTPSA id c26sm4356136wrb.87.2021.02.24.10.23.22
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 24 Feb 2021 10:23:22 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#46709: 28.0.50; Emacs crash in gnutls_handshake
References: <87czwsc5mz.fsf@HIDDEN> <87a6rt76ch.fsf@HIDDEN>
 <87o8g95r72.fsf@HIDDEN>
Date: Wed, 24 Feb 2021 19:23:21 +0100
In-Reply-To: <87o8g95r72.fsf@HIDDEN> (Robert Pluim's message of "Wed, 24
 Feb 2021 18:08:33 +0100")
Message-ID: <87k0qx5nqe.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46709
Cc: 46709 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Wed, 24 Feb 2021 18:08:33 +0100, Robert Pluim <rpluim@HIDDEN> s=
aid:

>>>>> On Wed, 24 Feb 2021 17:55:58 +0100, Lars Ingebrigtsen <larsi@HIDDEN=
> said:
    Lars> Yes, I think that this looks like the correct fix here.

    Robert> Except now the test suite fails. Back to the drawing board.

This really is the bug that keeps on giving. Turns out one of my
network cards (the fast one <sniff>) is buggy, in that it will say
it=CA=BCs passing packets when in fact it=CA=BCs not, so the patch is in fa=
ct ok
(but out of an excess of caution I won't push it till tomorrow, along
with some related test suite changes).

Robert




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46709; Package emacs. Full text available.

Message received at 46709 <at> debbugs.gnu.org:


Received: (at 46709) by debbugs.gnu.org; 24 Feb 2021 17:08:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 24 12:08:56 2021
Received: from localhost ([127.0.0.1]:35807 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lExeV-0007o4-Vr
	for submit <at> debbugs.gnu.org; Wed, 24 Feb 2021 12:08:56 -0500
Received: from mail-wr1-f53.google.com ([209.85.221.53]:38809)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1lExeT-0007nq-Cg
 for 46709 <at> debbugs.gnu.org; Wed, 24 Feb 2021 12:08:43 -0500
Received: by mail-wr1-f53.google.com with SMTP id b3so2602221wrj.5
 for <46709 <at> debbugs.gnu.org>; Wed, 24 Feb 2021 09:08:41 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :mime-version:content-transfer-encoding;
 bh=5YqERKhtnGtiXh/TfS93RXo3d5btL/wnWN5rpf77JCQ=;
 b=IoEwk3bYD35FWvMroCabfL99mBZDeRD8iqZRHH2gAJgQi8d2lNpCuGJ4SFr+gXFlJc
 tRN/nluIUZf13O8LZ6dqWa3uRoKhSTBcQcqUQo+gtfH88Bf1n0bYIyhg9nvn1QXQP4H5
 wnIa5QBu+CoGujBfDoIcvGvUnwek+DOXNAgOLpZTmJSsCBk1I01GTXmaPgR3Cdd6+Ros
 3vlGMR2rTtIxkrtwO++KUXd6l1nRVVlRxC2LG1Z0zc1BkX7kLEZkwi860lLvKJKJUFGT
 qU30Bpjd5rYFnGWpKjzBi+gsO/9A5XUIuV9gNMkdMinw93U7utZqfPw4WcS7ljeyajhD
 s8LA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:mime-version:content-transfer-encoding;
 bh=5YqERKhtnGtiXh/TfS93RXo3d5btL/wnWN5rpf77JCQ=;
 b=auYD5EZeH2MOboaG7eOuPhNSR6IVy7b2w78pS+tOFCOXyrPet6u7P0aw2Qq/aC/6Nl
 m2rF0D+ju0sGVp6y8HItw/qH7mKtfQwFmAn6BmDwQffzE648aAdkCJfpD1IbVZlCCDvS
 q0D1wqEfqxX7aj9vhsdYSaPP1DBdGqd7QvtnYN96gpEXF9GGOq7JiEAx0SZwzPlwv2Ah
 sB29Lh39sErfrEeh0MpdxgiHm4mCgB8GNHf1vvP/lAR5WPO/Fwxxowc5DDHrJ1GfJHtB
 kGtTA6R7ueQHcjXSD01fmSpxlimVRKqyD0HpYH1UciPwUCNquIrqP+6jdBr8XcOg3V3H
 1rTA==
X-Gm-Message-State: AOAM530Cyrva1b7VVIp4cfmLQ6t1xQ/QdgTUJu5jlVgYyj4jG7AXEMfX
 fQSQDwShoNVT602dCTZ39/pjM1ow/8Qm8g==
X-Google-Smtp-Source: ABdhPJzhH4XrQ06+98f9KEf+ns+vWzFVxmxoTzT5qM6KnxSM82vwPcwjnTNSjWcJymgNp4KD71CYUQ==
X-Received: by 2002:adf:ed44:: with SMTP id u4mr3430262wro.35.1614186515154;
 Wed, 24 Feb 2021 09:08:35 -0800 (PST)
Received: from rltb (91-175-207-237.subs.proxad.net. [91.175.207.237])
 by smtp.gmail.com with ESMTPSA id f17sm4128887wru.31.2021.02.24.09.08.33
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 24 Feb 2021 09:08:34 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#46709: 28.0.50; Emacs crash in gnutls_handshake
References: <87czwsc5mz.fsf@HIDDEN> <87a6rt76ch.fsf@HIDDEN>
Date: Wed, 24 Feb 2021 18:08:33 +0100
In-Reply-To: <87a6rt76ch.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 24 Feb 2021 17:55:58 +0100")
Message-ID: <87o8g95r72.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46709
Cc: 46709 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>>>> On Wed, 24 Feb 2021 17:55:58 +0100, Lars Ingebrigtsen <larsi@HIDDEN=
> said:

    Lars> Robert Pluim <rpluim@HIDDEN> writes:
    >> My reading of
    >> <https://gnutls.org/manual/gnutls.html#gnutls_005fhandshake> is that
    >> after receiving a fatal error, we should not call gnutls_handshake
    >> again. I=CA=BCve tested the following patch successfully. We current=
ly
    >> check only for GNUTLS_E_INTERRUPTED, but the list of non-fatal error
    >> codes is more than that, so perhaps more is needed.
    >>=20
    >> diff --git a/src/gnutls.c b/src/gnutls.c
    >> index aa245ee5c3..4d5a909db0 100644
    >> --- a/src/gnutls.c
    >> +++ b/src/gnutls.c
    >> @@ -625,6 +625,8 @@ gnutls_try_handshake (struct Lisp_Process *proc)
    >>=20
    >> while ((ret =3D gnutls_handshake (state)) < 0)
    >> {
    >> +      if (gnutls_error_is_fatal (ret))
    >> +	return emacs_gnutls_handle_error (state, ret);

    Lars> Yes, I think that this looks like the correct fix here.

Except now the test suite fails. Back to the drawing board.

Robert




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46709; Package emacs. Full text available.

Message received at 46709 <at> debbugs.gnu.org:


Received: (at 46709) by debbugs.gnu.org; 24 Feb 2021 16:56:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 24 11:56:09 2021
Received: from localhost ([127.0.0.1]:35748 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lExSL-0005MY-4n
	for submit <at> debbugs.gnu.org; Wed, 24 Feb 2021 11:56:09 -0500
Received: from quimby.gnus.org ([95.216.78.240]:44310)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lExSK-0005M3-94
 for 46709 <at> debbugs.gnu.org; Wed, 24 Feb 2021 11:56:08 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=+SK2pxhfdkCSeiTCOJyOjXrBaH+FjLJ4oMtWL4wyD7Y=; b=rfUtp7xvGViXFn3wsiVOWx6WdS
 iJkN75E+w6BkTFRp2eNOSAUkTV7Cw0Cba5eePMOelBKbx31F08GGyK9evf1RBO+HaI8jUXJIsmO0l
 ccVX6WLJ9AI2XnXF6WuQ5wMBXGJbjBhjG/sOAayLSXtACeDsXE6xqujWBQVh4Y7gjkR8=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lExSB-0005z6-MM; Wed, 24 Feb 2021 17:56:02 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Robert Pluim <rpluim@HIDDEN>
Subject: Re: bug#46709: 28.0.50; Emacs crash in gnutls_handshake
References: <87czwsc5mz.fsf@HIDDEN>
X-Now-Playing: Moor Mother & billy woods's _BRASS_: "Blak Forrest feat.
 Fielded"
Date: Wed, 24 Feb 2021 17:55:58 +0100
In-Reply-To: <87czwsc5mz.fsf@HIDDEN> (Robert Pluim's message of "Mon, 22
 Feb 2021 19:35:32 +0100")
Message-ID: <87a6rt76ch.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Robert Pluim <rpluim@HIDDEN> writes: > My reading of >
   <https://gnutls.org/manual/gnutls.html#gnutls_005fhandshake> is that > after
    receiving a fatal error, we should not call gnutls_handshake > again. Iʼve
    tested the following patch su [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46709
Cc: 46709 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Robert Pluim <rpluim@HIDDEN> writes:

> My reading of
> <https://gnutls.org/manual/gnutls.html#gnutls_005fhandshake> is that
> after receiving a fatal error, we should not call gnutls_handshake
> again. I=CA=BCve tested the following patch successfully. We currently
> check only for GNUTLS_E_INTERRUPTED, but the list of non-fatal error
> codes is more than that, so perhaps more is needed.
>
> diff --git a/src/gnutls.c b/src/gnutls.c
> index aa245ee5c3..4d5a909db0 100644
> --- a/src/gnutls.c
> +++ b/src/gnutls.c
> @@ -625,6 +625,8 @@ gnutls_try_handshake (struct Lisp_Process *proc)
>
>    while ((ret =3D gnutls_handshake (state)) < 0)
>      {
> +      if (gnutls_error_is_fatal (ret))
> +	return emacs_gnutls_handle_error (state, ret);

Yes, I think that this looks like the correct fix here.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46709; Package emacs. Full text available.
Added tag(s) patch. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 22 Feb 2021 18:36:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 22 13:36:15 2021
Received: from localhost ([127.0.0.1]:57509 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lEG47-00052i-2F
	for submit <at> debbugs.gnu.org; Mon, 22 Feb 2021 13:36:15 -0500
Received: from lists.gnu.org ([209.51.188.17]:49584)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rpluim@HIDDEN>) id 1lEG45-00052Y-80
 for submit <at> debbugs.gnu.org; Mon, 22 Feb 2021 13:36:13 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:39020)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rpluim@HIDDEN>) id 1lEG42-0005lf-Fn
 for bug-gnu-emacs@HIDDEN; Mon, 22 Feb 2021 13:36:11 -0500
Received: from mail-wr1-x433.google.com ([2a00:1450:4864:20::433]:41820)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <rpluim@HIDDEN>) id 1lEG40-0007B8-7u
 for bug-gnu-emacs@HIDDEN; Mon, 22 Feb 2021 13:36:10 -0500
Received: by mail-wr1-x433.google.com with SMTP id c7so3387684wru.8
 for <bug-gnu-emacs@HIDDEN>; Mon, 22 Feb 2021 10:36:07 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=iZ7N1XKux2LbMtX1p2lcXo11Lj/75IYD2echMfvT5JM=;
 b=sIr1bySaA93Xjv0CHCb1oBQWm2Xoz1INp9RcIfSyjhfjResWLXSxA7y1gVrdtrFo7o
 JoYv+F38+uZD8Nj2wE2n/N3zg0hQDx4GXJB/QmiHRbazktLupd+VgdNtQ0Xiruct+FPU
 BDD34Iw1LuSZdvNJT4GcgsGjmrY4bEBuoyGBgIPDo65rMRLMgE/ISbMdGbzYYOYnBEgM
 A7keqwGTDrInTyuBuVqsz/tKmxvtgllLZCym9z9QmRFaUBng49wgfBKgvjQM+ae2Fg3M
 BZ3AhW0fZNoVqrfLYnA/0ZizPz5jNGDfMMFgMa7k3m8nljlToa19K4pAOaSt/s/LLY+G
 BjMA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=iZ7N1XKux2LbMtX1p2lcXo11Lj/75IYD2echMfvT5JM=;
 b=oUqfSE/2ajAG65VkA847r8uxnTv+49otLnNG7MDwWhsQ3ylFfdJrNEVAZZPxJWpk4V
 txWL0dRcDvWOuMPSjRYb3aX37rGdYZNQ50Drgl02Az3f+Ac5ylCmczvndHz4VgS6Gh/y
 bPEwoGWUe1rU8NmSiBahzbl8fd9DcBy0qKBrREasjMOigq10wfKxDgYLQrZiiTwJaWNa
 TdO3hzYaWVMlwFpEOGZuycopJM9iCqHuNvRJZwWuNyC/kYEudVbyc57HAwZTnIodD/4l
 WevrzAHcMZgKq0kZV2vIqPB+pr9evbJBhMZUhCY4UgWXdn9WUR1FDvRwUfwnEnghrg2C
 zlpQ==
X-Gm-Message-State: AOAM532t2Xy3nY2PLU/xZHAq6No0olrC+8TeUhKPpW5HECBN6TOBkH2K
 TrDPyXcIg8pjjTVxyAv+2jcmR1YGi9zKnw==
X-Google-Smtp-Source: ABdhPJxmw0Hc4cNUqFmCrQOgwQBu/VnGWpxc+r333qwDyesRuoHZgeEDPSvutuGVF7dntq0UQY/SrQ==
X-Received: by 2002:a05:6000:18a:: with SMTP id
 p10mr23040450wrx.166.1614018965337; 
 Mon, 22 Feb 2021 10:36:05 -0800 (PST)
Received: from rltb (91-175-207-237.subs.proxad.net. [91.175.207.237])
 by smtp.gmail.com with ESMTPSA id h17sm21411698wrw.74.2021.02.22.10.36.04
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 22 Feb 2021 10:36:04 -0800 (PST)
From: Robert Pluim <rpluim@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; Emacs crash in gnutls_handshake
X-Debbugs-No-Ack: yes
Date: Mon, 22 Feb 2021 19:35:32 +0100
Message-ID: <87czwsc5mz.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Received-SPF: pass client-ip=2a00:1450:4864:20::433;
 envelope-from=rpluim@HIDDEN; helo=mail-wr1-x433.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


1. Disconnect your network cable
2. Set a static IP on your ethernet interface
3. Comment out the '(skip-unless internet-is-working)' line in
test/lisp/net/network-stream-tests.el
4. Run:
    cd test
    make network-stream-tests SELECTOR=3Dconnect-to-tls-ipv4-nowait

Output:

    make[1]: Entering directory '/home/rpluim/repos/emacs-real-master/test'
      GEN      lisp/net/network-stream-tests.log
    No DNS server configuration found
    Running 1 tests (2021-02-22 19:05:20+0100, selector `connect-to-tls-ipv=
4-nowait')
    gnutls-serv: HTTP Server listening on IPv4 0.0.0.0 port 44331...done

    make[1]: *** [Makefile:192: lisp/net/network-stream-tests.log] Error 141
    make[1]: Leaving directory '/home/rpluim/repos/emacs-real-master/test'
    make: *** [Makefile:258: lisp/net/network-stream-tests] Error 2

This is emacs crashing in gnutls_try_handshake at gnutls.c:629 the
second time we call gnutls_handshake. The first time we called it we
got -53 GNUTLS_E_PUSH_ERROR, which is not surprising, because the test
has deleted the listening gnutls-serv process.

My reading of
<https://gnutls.org/manual/gnutls.html#gnutls_005fhandshake> is that
after receiving a fatal error, we should not call gnutls_handshake
again. I=CA=BCve tested the following patch successfully. We currently
check only for GNUTLS_E_INTERRUPTED, but the list of non-fatal error
codes is more than that, so perhaps more is needed.

diff --git a/src/gnutls.c b/src/gnutls.c
index aa245ee5c3..4d5a909db0 100644
--- a/src/gnutls.c
+++ b/src/gnutls.c
@@ -625,6 +625,8 @@ gnutls_try_handshake (struct Lisp_Process *proc)
=20
   while ((ret =3D gnutls_handshake (state)) < 0)
     {
+      if (gnutls_error_is_fatal (ret))
+	return emacs_gnutls_handle_error (state, ret);
       do
 	ret =3D gnutls_handshake (state);
       while (ret =3D=3D GNUTLS_E_INTERRUPTED);



In GNU Emacs 28.0.50 (build 4, x86_64-pc-linux-gnu, GTK+ Version 3.24.5, ca=
iro version 1.16.0)
 of 2021-02-21 built on rltb
Repository revision: d15a42ac453c47c4da8ba1a66170dee106541d63
Repository branch: master




Report forwarded to bug-gnu-emacs@HIDDEN:
bug#46709; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 25 Feb 2021 16:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.